var playa_ie = false;
var quick_save_btn;

// ------------------------------
// Utility functions
// ------------------------------


var oldEventFuncs = new Array();


function bk_addEvent(e, f)
{
	eval(
		"if (typeof "+e+" == 'function') {"+
			"var oldfunc = "+e+";"+
			e+" = function(e){ "+
				"oldfunc(e);"+
				"f(e);"+
			"};"+
			"oldEventFuncs['"+e.replace(".","")+"'] = oldfunc;"+
		"} else "+e+" = f;"
	);
}


function bk_clearEvent(e)
{
	eval(e+" = oldEventFuncs['"+e.replace(".","")+"'];");
}


function bk_getEventTarget(e)
{
	e = e || window.event;
	var t = e.target || e.srcElement;
	if (t.nodeType == 3) t = t.parentNode;
	return t;
}


function bk_insertAfter(newElement, targetElement)
{ 
	var parent = targetElement.parentNode; 
	if (parent.lastChild == targetElement)
	{
		parent.appendChild(newElement); 
	}
	else
	{
		parent.insertBefore(newElement, targetElement.nextSibling);
	}
}


function bk_inArray(needle, haystack)
{
	if ( ! needle || ! haystack || ! haystack.length) return false;
	for (var i in haystack)
	{
		if (haystack[i] == needle) return true;
	}
	return false;
}

function bk_getClasses(e)
{
	return e.className.split(" ");
}

function bk_checkClass(e, c)
{
	if ( ! e.className) return false;
	var classes = bk_getClasses(e);
	if (bk_inArray(c, classes)) return true;
	return false;
}


function bk_addClass(e, c)
{
	// return false if class already exists
	if (bk_checkClass(e, c)) return false;
	
	var classes = bk_getClasses(e);
	classes.push(c);
	e.className = classes.join(" ");
	
	return true;
}


function bk_removeClass(e, c)
{
	// return false if class doesn't exist
	if ( ! bk_checkClass(e, c)) return false;
	
	var classes = bk_getClasses(e);
	var newClasses = new Array();
	for (var i in classes)
	{
		if (classes[i] != c) newClasses.push(classes[i]);
	}
	
	if (newClasses.length) var newClassName = newClasses.join(" ");
	else var newClassName = "";
	e.className = newClassName;
	
	return true;
}


function bk_toggleClass(e, c)
{
	if (bk_addClass(e, c)) return true;
	bk_removeClass(e, c);
	return false;
}


function bk_disableSelection(e)
{
	e.onselectstart = function()
	{
		return false;
	};
	e.unselectable = "on";
	e.style.MozUserSelect = "none";
	e.style.cursor = "default";
}


function bk_quantify(num, singular, plural)
{
	if (parseInt(num) == 1) return singular;
	else return plural;
}


// ------------------------------
// Init
// ------------------------------


function playa_init(field_id, selectionLimit)
{
	var playa_id = "playa-"+field_id;
	var playa = document.getElementById(playa_id);
	playa.form_field = document.getElementById("field_id_"+field_id);
	playa.original_value = playa.form_field.value;
	
	if (selectionLimit) playa.selectionLimit = selectionLimit;
	
	var tds = playa.getElementsByTagName("td");
	for (var i=0; i<tds.length; i++)
	{
		var td = tds[i];
		
		if (bk_checkClass(td, "list"))
		{
			var list = td.getElementsByTagName("ul")[0];
			
			if (bk_checkClass(td, "options"))
			{
				playa.optionsList = list;
			}
			else if (bk_checkClass(td, "selections"))
			{
				playa.selectionsList = list;
			}
		}
		else if (bk_checkClass(td, "info"))
		{
			if (bk_checkClass(td, "options"))
			{
				playa.optionsInfo = td;
			}
			else if (bk_checkClass(td, "selections"))
			{
				playa.selectionsInfo = td;
			}
		}
		else if (bk_checkClass(td, "btns"))
		{
			var buttons = td.getElementsByTagName("input");
			for (var j=0; j<buttons.length; j++)
			{
				var button = buttons[j];
				button.playa = playa;
				
				if (bk_checkClass(button, "select-options"))
				{
					playa.selectButton = button;
					button.onmousedown = function()
					{
						playa_selectOptions(this.playa);
					}
				}
				else if (bk_checkClass(button, "deselect-options"))
				{
					playa.deselectButton = button;
					button.onmousedown = function()
					{
						playa_deselectOptions(this.playa);
					}
				}
			}
		}
	}
	
	playa.console = document.getElementById(playa_id+"-console");
	
	
	// -- setup options list
	
	var h4s = playa.optionsList.getElementsByTagName("h4");
	for (var j=0; j<h4s.length; j++)
	{
		var h4 = h4s[j];
		var collapse = document.createElement("img");
		collapse.src = playa_dir+"collapse.gif";
		h4.insertBefore(collapse, h4.firstChild);
		h4.onmousedown = function()
		{
			playa_expandCollapse(this.parentNode);
		}
		
		var lis = h4.parentNode.getElementsByTagName("li");
		for (var k=0; k<lis.length; k++)
		{
			var li = lis[k];
			playa_initOption(li, playa, true)
		}
	}
	
	if (h4s.length == 1)
	{
		bk_addClass(playa, "hide-heading");
	}
	else if ( ! playa_ie)
	{
		bk_addClass(playa, "scroll-headings");
		playa.optionsList.onscroll = function(e)
		{
			playa_onOptionsScroll(e, this);
		}
	}
	
	
	// -- setup selections list
	
	var lis = playa.selectionsList.getElementsByTagName("li");
	for (var k=0; k<lis.length; k++)
   {
   	var li = lis[k];
   	playa_initSelectedOption(playa, li);
   }
   
   bk_disableSelection(playa.selectionsList);
	
	
	playa_updateInnerShadows(playa);
	playa_checkOverflowingItems(playa);
	
	
	// -- find Quick Save button
	
	if ( ! quick_save_btn)
	{
		var inputs = document.getElementsByTagName("input");
		for (var i=0; i<inputs.length; i++)
		{
			var input = inputs[i];
			if (input.name == "save")
			{
				quick_save_btn = input;
				break;
			}
		}
	}
}


function playa_expandCollapse(list)
{
	var img = list.getElementsByTagName("img")[0];
	img.src = playa_dir + (bk_toggleClass(list, "collapsed") ? "expand.gif" : "collapse.gif");
}


function playa_onOptionsScroll(e, list)
{
	var listY = playa_getPosition(list).y;
	var listScrollY = list.scrollTop;
	
	var h4s = list.getElementsByTagName("h4");
	for (var i=0; i<h4s.length; i++)
	{
		var h4 = h4s[i];
		var li = h4.parentNode;
		
		var liY = playa_getPosition(li).y - listY;
		var liScrollY = listScrollY - liY;
		
		if (liScrollY > 0)
		{
			h4.style.top = liScrollY+"px";
		}
		else
		{
			h4.style.top = "0px";
		}
	}
}


// ------------------------------
// Option Selection/Deselection
// ------------------------------


// Toggle "active" state on press
function playa_initOption(li, playa, inOptionsList)
{
	li.playa = playa;
	li.inOptionsList = inOptionsList;
	
	if (playa_ie && playa_ie <= 6)
	{
		li.onmouseover = function()
		{
			if ( ! draggee) bk_addClass(this, "hover");
		}
		li.onmouseout = function()
		{
			bk_removeClass(this, "hover");
		}
	}
	
	li.onmousedown = function(e)
	{
		// Ignore event if target was the dragHandle
		if (bk_getEventTarget(e) != this) return;
		
		playa_unhighlightOption(this);
		
		bk_toggleClass(this, "active");
	}
}


function playa_getActiveOptions(list)
{
	var activeOptions = new Array();
	
	var items = list.getElementsByTagName("li");
	for (var i=0; i<items.length; i++)
	{
		var item = items[i];
		if (bk_removeClass(item, "active"))
		{
			activeOptions.push(item);
		}
	}
	
	return activeOptions;
}


function playa_selectOptions(playa)
{
	var activeOptions = playa_getActiveOptions(playa.optionsList);
	
	for (var i in activeOptions)
	{
		var li = activeOptions[i];
		var clone = li.cloneNode(true);
		bk_addClass(li, "selected");
		clone.id += "-selected";
		
		var dragHandle = document.createElement("div");
		dragHandle.className = "dragHandle";
		clone.appendChild(dragHandle);
		
		playa_initSelectedOption(playa, clone);
		
		playa.selectionsList.appendChild(clone);
		playa_highlightOption(clone);
	}
	
	playa_updateInnerShadows(playa);
	playa_checkOverflowingItems(playa);
	
}


function playa_deselectOptions(playa)
{
	var activeOptions = playa_getActiveOptions(playa.selectionsList);
	
	for (var i in activeOptions)
	{
		var clone = activeOptions[i];
		var id = clone.id.substring(0, clone.id.length-9);
		clone.parentNode.removeChild(clone);
		var li = document.getElementById(id);
		bk_removeClass(li, "selected");
		playa_highlightOption(li);
	}
	
	playa_updateInnerShadows(playa);
	playa_checkOverflowingItems(playa);
}


function playa_updateInnerShadows(playa)
{
	var lists = new Array(playa.optionsList, playa.selectionsList);
	var infos = new Array(playa.optionsInfo, playa.selectionsInfo);
	
	for (var i in lists)
	{
		var list = lists[i];
		var info = infos[i];
		
		var height = 0;
		var numItems = 0;
		
		var lis = list.getElementsByTagName("li");
		for (var j=0; j<lis.length; j++)
		{
			var li = lis[j];
			if (bk_checkClass(li, "heading"))
			{
				if ( ! bk_checkClass(playa, "hide-heading"))
				{
					height += 21;
				}
			}
			else if ( ! bk_checkClass(li, "selected"))
			{
				height += 21;
				if (bk_checkClass(li, "playa-status-open"))
				{
					numItems ++;
				}
			}
		}
		list.style.backgroundPosition = "0 "+height+"px";
		
		list.numItems = numItems;
		var text = numItems + " ";
		
		if (list == playa.optionsList)
		{
			text += "open " + bk_quantify(numItems, "item", "items") + " available";
		}
		else
		{
			if (playa.selectionLimit)
			{
				text += "of " + playa.selectionLimit + " allowed open " + bk_quantify(playa.selectionLimit, "item", "items");
				if (numItems > playa.selectionLimit)
				{
					bk_addClass(info, "too-many-items");
				}
				else
				{
					bk_removeClass(info, "too-many-items");
				}
			}
			else
			{
				text += bk_quantify(numItems, "item", "items");
			}
			text += " selected";
		}
		
		info.innerHTML = text;
	}
}


function playa_checkOverflowingItems(playa)
{
	var field_value = "";
	
	var items = playa.selectionsList.getElementsByTagName("li");
	var visibleItems = 0;
	for (var i=0; i<items.length; i++)
	{
		var item = items[i];
		
		if (playa.selectionLimit)
		{
			if (bk_checkClass(item, "playa-status-open"))
			{
				visibleItems ++;
				if (visibleItems > playa.selectionLimit)
				{
					bk_addClass(item, "overflow");
				}
				else
				{
					bk_removeClass(item, "overflow");
				}
			}
		}
		
		// -- remove 'playa-xxx-option-' and '-selected
		var entry_id = item.id.substring(playa.id.length+8, item.id.length-9);
		
		if (field_value) field_value += ",";
		field_value += entry_id;
	}
	playa.form_field.value = field_value;
	
	if (quick_save_btn)
	{
		//quick_save_btn.disabled = (playa.form_field.value != playa.original_value) ? true : false;
		quick_save_btn.disabled = true;
	}
}


// ------------------------------
// Option Highlight
// - Initiated after selection/deselection
// ------------------------------


function playa_highlightOption(li)
{
	playa_unhighlightOption(li);
	li.highlightTimeouts = new Array();
	
	li.style.backgroundColor = "#ffffaf";
	
	var alphas = "abcdef";
	var expression = "document.getElementById('"+li.id+"').style.backgroundColor='#ffff";
	for (var i=0; i<6; i++)
	{
		var b = alphas.charAt(i);
		
		var time1 = 1000 + (100 * i);
		var time2 = time1 + 50;
		
		var timeout1 = setTimeout(expression+b+"8';", time1);
		if (i < 5) var timeout2 = setTimeout(expression+b+"f';", time2);
		else var timeout2 = setTimeout("playa_unhighlightOption(document.getElementById('"+li.id+"'));", time2);
		
		li.highlightTimeouts.push(timeout1);
		li.highlightTimeouts.push(timeout2);
	}
	li.highlightTimeouts.push();
}


function playa_unhighlightOption(li)
{
	li.style.backgroundColor = "";
	if ( ! li.highlightTimeouts) return;
	
	for (var i in li.highlightTimeouts)
	{
		clearTimeout(li.highlightTimeouts[i]);
	}
}


// ------------------------------
// Selected Option Drag
// ------------------------------


var draggee, draggeeIndex, allSelections, startDragMouseY, startDragMouseYOffset;


function playa_initSelectedOption(playa, li)
{
	playa_initOption(li);
	
	var dragHandle = li.getElementsByTagName("div")[0];
	dragHandle.onmousedown = function(e)
	{
		playa_startDrag(this.parentNode, e);
	}
	
	li.playa = playa;
}


function playa_assembleAllSelections()
{
	allSelections = draggee.parentNode.getElementsByTagName("li");
	
	// Pointless to initiate drag if there's only one selection
	if (allSelections.length < 2) return false;
	
	// Find the draggee's index in allSelectedOptions
	for (var i=0; i<allSelections.length; i++)
	{
		if (allSelections[i] == draggee)
		{
			draggeeIndex = i;
			break;
		}
	}
	
	return true;
}


function playa_startDrag(li, e)
{
	draggee = li;
	
	if ( ! playa_assembleAllSelections()) return;
	
	bk_addClass(document.body, "playa-dragging");
	playa_unhighlightOption(li);
	bk_addClass(li, "draggee");
	bk_removeClass(li, "active");
	
	startDragMouseY = playa_mouseCoords(e).y;
	startDragMouseYOffset = startDragMouseY - playa_getPosition(li).y;
	
	bk_addEvent("document.onmouseup", playa_stopDrag);
	bk_addEvent("document.onmousemove", playa_mouseMove);
}


function playa_stopDrag()
{
	bk_removeClass(document.body, "playa-dragging");
	bk_removeClass(draggee, "draggee");
	
	draggee = null;
	bk_clearEvent("document.onmouseup");
	bk_clearEvent("document.onmousemove");
}


function playa_mouseMove(e)
{
	e = e || window.event;
	var mouseY = playa_mouseCoords(e).y;
	var mouseYOffset = mouseY - playa_getPosition(draggee).y + draggee.playa.selectionsList.scrollTop;
	
	if (
			(mouseYOffset <= 0 && draggeeIndex != 0)
		||
			(mouseYOffset > 21 && draggeeIndex != allSelections.length-1)
		)
	{
		if (mouseYOffset <= 0)
		{
			// -- Drag Up
			
			var prevSelection = allSelections[draggeeIndex-1];
			var clone = prevSelection.cloneNode(true);
			prevSelection.parentNode.removeChild(prevSelection);
			bk_insertAfter(clone, draggee);
		}
		else
		{
			// -- Drag Down
			
			var nextSelection = allSelections[draggeeIndex+1];
			var clone = nextSelection.cloneNode(true);
			nextSelection.parentNode.removeChild(nextSelection);
			draggee.parentNode.insertBefore(clone, draggee);
		}
		
		playa_initSelectedOption(draggee.playa, clone);
		playa_assembleAllSelections();
		playa_checkOverflowingItems(draggee.playa);
	}
}


function playa_mouseCoords(e) {
	var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX;
		posy = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	
	return { x:posx, y:posy };
	// posx and posy contain the mouse position relative to the document
	// Do something with this information
}



function playa_getMouseOffset(target, e)
{
	e = e || window.event;

	var docPos = playa_getPosition(target);
	var mousePos = playa_mouseCoords(e);
	return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
}


function playa_getPosition(e)
{
	var left = 0;
	var top  = 0;
	
	e = e || window.event;

	while (e.offsetParent)
	{
		left += e.offsetLeft;
		top += e.offsetTop;
		e = e.offsetParent;
	}

	left += e.offsetLeft;
	top  += e.offsetTop;

	return { x:left, y:top };
}


